local AddonName, GGL = ...
local GUI = GGL.GUI
local Sets = GGL.Options.Sets
local Global = {}
GGL.Options.SourceFilter = Global

local L = GGL.Locale

-- lua
local ipairs = ipairs

-- WoW

-- Libs
local AceGUI = LibStub("AceGUI-3.0")

-- ##################
-- local
-- ##################
local Helper

local LOOT_SOURCE_TYPES = GGL.LOOT_SOURCE_TYPES
local SUB_SOURCE_FLAG, SUB_SOURCE_FLAG_ICONS = GGL.SUB_SOURCE_FLAG, GGL.SUB_SOURCE_FLAG_ICONS

local CheckBoxList = {
    { LOOT_SOURCE_TYPES.mobs.id,                648206,                                                     LOOT_SOURCE_TYPES.mobs.name, },
    { LOOT_SOURCE_TYPES.lockbox.id,             134344,                                                     LOOT_SOURCE_TYPES.lockbox.name, },
    { LOOT_SOURCE_TYPES.chest.id,               SUB_SOURCE_FLAG_ICONS[SUB_SOURCE_FLAG.OPENING],             LOOT_SOURCE_TYPES.chest.name, },
    { LOOT_SOURCE_TYPES.disenchanting.id,       SUB_SOURCE_FLAG_ICONS[SUB_SOURCE_FLAG.DISENCHANTING],       LOOT_SOURCE_TYPES.disenchanting.name, },
    { LOOT_SOURCE_TYPES.fishing.id,             SUB_SOURCE_FLAG_ICONS[SUB_SOURCE_FLAG.FISHING],             LOOT_SOURCE_TYPES.fishing.name, },
    { LOOT_SOURCE_TYPES.herbalism.id,           SUB_SOURCE_FLAG_ICONS[SUB_SOURCE_FLAG.HERBALISM],           LOOT_SOURCE_TYPES.herbalism.name, },
    { LOOT_SOURCE_TYPES.mining.id,              SUB_SOURCE_FLAG_ICONS[SUB_SOURCE_FLAG.MINING],              LOOT_SOURCE_TYPES.mining.name, },
    { LOOT_SOURCE_TYPES.skinning.id,            SUB_SOURCE_FLAG_ICONS[SUB_SOURCE_FLAG.SKINNING],            LOOT_SOURCE_TYPES.skinning.name, },
    { LOOT_SOURCE_TYPES.pickpocket.id,          SUB_SOURCE_FLAG_ICONS[SUB_SOURCE_FLAG.PICK_POCKET],         LOOT_SOURCE_TYPES.pickpocket.name, },
    { LOOT_SOURCE_TYPES.scrapping.id,           SUB_SOURCE_FLAG_ICONS[SUB_SOURCE_FLAG.SCRAPPING],           LOOT_SOURCE_TYPES.scrapping.name, },
    { LOOT_SOURCE_TYPES.island_expedition.id,   SUB_SOURCE_FLAG_ICONS[SUB_SOURCE_FLAG.ISLAND_EXPEDITION],   LOOT_SOURCE_TYPES.island_expedition.name, },
    { LOOT_SOURCE_TYPES.quest.id,               SUB_SOURCE_FLAG_ICONS[SUB_SOURCE_FLAG.QUEST],               LOOT_SOURCE_TYPES.quest.name, },
    { LOOT_SOURCE_TYPES.world_quest.id,         SUB_SOURCE_FLAG_ICONS[SUB_SOURCE_FLAG.WORLD_QUEST],         LOOT_SOURCE_TYPES.world_quest.name, },
    { LOOT_SOURCE_TYPES.special.id,             SUB_SOURCE_FLAG_ICONS[SUB_SOURCE_FLAG.SPECIAL],             LOOT_SOURCE_TYPES.special.name, },
    { LOOT_SOURCE_TYPES.mission_table.id,       SUB_SOURCE_FLAG_ICONS[SUB_SOURCE_FLAG.MISSION_TABLE],       LOOT_SOURCE_TYPES.mission_table.name, },
}

-- ##################
-- local helper
-- ##################
local function SourceCheck_OnValueChanged(self, event, state)
    local sourceID = self:GetUserData("id")
    if state then
        Helper.Data["selectedDB"][sourceID] = nil
    else
        Helper.Data["selectedDB"][sourceID] = true
    end
    Helper:SaveDB()
    -- Helper:RefreshSelectedTab()
end

local function SetOnTabGroupConfigSelected(content, db, tabID)
    local base = AceGUI:Create("SimpleGroup")
    base:SetFullWidth(true)
    base:SetLayout("List")

    -- Soulbound

    for index, source in ipairs(CheckBoxList) do
        local check = AceGUI:Create("CheckBox")
        check:SetLabel(source[3])
        check:SetImage(source[2])
        check:SetValue(not db[source[1]])
        check:SetCallback("OnValueChanged", SourceCheck_OnValueChanged)
        check:SetUserData("id", source[1])
        base:AddChild(check)
    end


    content:AddChild(base)
end

-- ##################
-- options
-- ##################

local function Options(AceGUI, container)
    Helper = Sets:GetBaseGroup(container, GGL.SET_ID_LIST.LootSource)

    -- empty for now
    local tabs = {}

    --Helper:SetOnTabGroupSelected(SetOnTabGroupSelected)
    Helper:SetOnTabGroupConfigSelected(SetOnTabGroupConfigSelected)

    Helper:SetTabGroupContent(tabs, true)
end

-- Add into Options
GGL.Options:AddIntoTree(Options, L["Loot Source"], "sets_sourcefilter", "sets")